//this is needed by KOS
#define _arch_dreamcast


/* Appwizard blank main template by Dovoto
	Assumes you are using KOS
*/

#define plotapixel(x,y,color) vram_s[(y)*640+(x)]=(color)
#define BFPrint(xx,yy,text) bfont_draw_str(vram_s+(((yy)*640)+(xx)), 640, 0, text)

#define PACK_RGB565(r,g,b) (((r>>3)<<11)|((g>>2)<<5)|((b>>3)<<0))

void line_fast (long x1, long y1, long x2, long y2, unsigned char r, unsigned char g, unsigned char b);
int sgn (long a);

#include <kos.h>



uint16 utemp, utemp2;
int16 temp, temp2, temp3, temp4;
uint8 tempbuffer[512];
uint8 meep[12];
uint8 vmu1addy, keyb1addy;
uint8 fat[512];


struct vmu_file {
	uint8	 type;				// 1 byte
	uint8  copy;				// 1 byte
	uint16  firstblock;		// 2 bytes
	char   name[13];			// 12 bytes
	uint8  creationtime[8];	// 8 bytes
	uint16 size;				// 2 bytes
	uint16 offset;				// 2 bytes
	uint8   meep[4];			// 4 bytes
									//	-------
								//	 = 32 bytes :D
};

struct vmu_file vmudir[20];
uint8 max_files;


void triangle(long x1,long y1,long x2,long y2,long x3,long y3,uint8 r, uint8 g, uint8 b);

void read_vmu_dir(void)
{
	vmu1addy = maple_first_vmu();
	vmu_block_read(vmu1addy, 253, tempbuffer);
	for(temp=0;temp<16;temp++)
	{
		vmudir[temp].type	= tempbuffer[(temp*32)+0x00];	
		vmudir[temp].copy	= tempbuffer[(temp*32)+0x01];
		vmudir[temp].firstblock	= tempbuffer[(temp*32)+0x02];

		for(temp2=0;temp2<12;temp2++)
			vmudir[temp].name[temp2] = tempbuffer[(temp*32)+0x04+temp2];
		vmudir[temp].name[13] = '\0';	// adds a null character to the end to signify end of string

		for(temp2=0;temp2<8;temp2++)
			vmudir[temp].creationtime[temp2] = tempbuffer[(temp*32)+0x10+temp2];

		vmudir[temp].size	= tempbuffer[(temp*32)+0x18];
		vmudir[temp].offset = tempbuffer[(temp*32)+0x1a];

		for(temp2=0;temp2<4;temp2++)
			vmudir[temp].meep[temp2] = tempbuffer[(temp*32)+0x1c+temp2];
		
		if(vmudir[temp].type==0)
		{
			max_files = temp-1;
			break;
		}
	}
}

void triangle(long x1,long y1,long x2,long y2,long x3,long y3,uint8 r, uint8 g, uint8 b)
{
	line_fast(x1,y1,x2,y2,r,g,b);
	line_fast(x1,y1,x3,y3,r,g,b);
	line_fast(x2,y2,x3,y3,r,g,b);
}

int main(int argc, char **argv) 
{
	char *meep;
	int8 key, selected=-1;
	uint16 nextblock;
	uint16 curblock;
	int8 currpos=0;
	int cont;
	cont_cond_t cond;
	char tempit[5];
	kos_init_all(ALL_ENABLE, ROMDISK_NONE);
	cont = maple_first_controller();
	read_vmu_dir();
	BFPrint(10,10,"VMUFrog r1, By: The Black Frog,");
	BFPrint(10,40,"http://www.TheBlackFrog.8m.com");
	BFPrint(10,70,"Press Up/Down to change selection, A to send");

	for(temp=0;temp<(max_files+1);temp++)
	{
		BFPrint( 100, 100+(temp*30), vmudir[temp].name);
//		sprintf(tempit, "| Blocks: %d", vmudir[temp].size);
//		BFPrint(260,100+(temp*30), tempit);
	}
	currpos=0;
	/*
	line_fast(50,100+((currpos*30)+10),99,100+((currpos*30)+10),255,255,255);
	line_fast(75,100+(currpos*30)     ,99,100+((currpos*30)+10),255,255,255);
	line_fast(75,100+((currpos*30)+20),99,100+((currpos*30)+10),255,255,255);
	*/
for(temp=0;temp<10;temp++)
{
	plotapixel(79+(temp*2),100+(currpos*30)+temp,PACK_RGB565(255,255,255));
	plotapixel(79+(temp*2),100+(currpos*30)+20-temp,PACK_RGB565(255,255,255));
}
	while(selected==-1)
	{
		timer_spin_sleep(100);
		cont_get_cond(cont, &cond);
		if(!(cond.buttons & CONT_A))
			selected=currpos;
		if (!(cond.buttons & CONT_DPAD_UP))
		{
			for(temp=0;temp<10;temp++)
			{
				plotapixel(79+(temp*2),100+(currpos*30)+temp,PACK_RGB565(0,0,0));
				plotapixel(79+(temp*2),100+(currpos*30)+20-temp,PACK_RGB565(0,0,0));
			}
			currpos-=1;
			if(currpos<0)
				currpos=max_files;
			for(temp=0;temp<10;temp++)
			{
				plotapixel(79+(temp*2),100+(currpos*30)+temp,PACK_RGB565(255,255,255));
				plotapixel(79+(temp*2),100+(currpos*30)+20-temp,PACK_RGB565(255,255,255));
			}
		}
		if (!(cond.buttons & CONT_DPAD_DOWN))
		{
			for(temp=0;temp<10;temp++)
			{
				plotapixel(79+(temp*2),100+(currpos*30)+temp,PACK_RGB565(0,0,0));
				plotapixel(79+(temp*2),100+(currpos*30)+20-temp,PACK_RGB565(0,0,0));
			}
			currpos+=1;
			if(currpos>max_files)
				currpos=0;
			for(temp=0;temp<10;temp++)
			{
				plotapixel(79+(temp*2),100+(currpos*30)+temp,PACK_RGB565(255,255,255));
				plotapixel(79+(temp*2),100+(currpos*30)+20-temp,PACK_RGB565(255,255,255));
			}
		}

	}
	sprintf(tempit,"Now Sending %s...", vmudir[selected].name);
	BFPrint(10,350,tempit);
	BFPrint(10,370,"Be Patient. It can take up to three minutes!");
	vmu_block_read(vmu1addy, 254, fat);
	printf("everything_after_here_is%s\n", vmudir[selected].name);
	curblock = vmudir[selected].firstblock;
	temp2=1;
	while(temp2)
	{
		nextblock = fat[curblock*2] | fat[(curblock*2)+1]<<8;
		if(nextblock == 0xfffa) temp2=0;
		vmu_block_read(vmu1addy, curblock, tempbuffer);
		for(temp=0;temp<512;temp++)
		{
			if(tempbuffer[temp]!=0x00)
				printf("%c", tempbuffer[temp]);
			else
				printf("NULL");

		}
		curblock = nextblock;
	}

	BFPrint(10,400,"Send Successfully! Now close the dos window (lil X in corner ;)");
	BFPrint(10,430,"And run Step2.exe, then run Step3.bat and it will be done!");
	
	while(1);
	kos_shutdown_all();
	return 0;
}

void line_fast (long x1, long y1, long x2, long y2, unsigned char r, unsigned char g, unsigned char b)
{
   long i, dx, dy, sdx, sdy, dxabs, dyabs, x, y, px, py;

   dx = x2 - x1;
   dy = y2 - y1;

   if (sgn(dx) != 1)
      dxabs = (dx * -1);
   else
      dxabs = (dx);

   if (sgn(dx) != 1)
      dyabs = (dy * -1);
   else
      dyabs = (dy);

   sdx = sgn(dx);
   sdy = sgn(dy);

   x = dyabs >> 1;
   y = dxabs >> 1;

   px = x1;
   py = y1;

   vram_s[py*640+px] = PACK_RGB565(r,g,b);
   
   if (dxabs >= dyabs)
   {
      for (i = 0; i < dxabs; i++)
      {
         y += dyabs;

         if (y >= dxabs)
         {
            y -= dxabs;
            py += sdy;
         }

         px += sdx;
         vram_s[py*640+px] = PACK_RGB565(r,g,b);
      }
   }
   else
   {

      for (i = 0; i < dyabs; i++)
      {
         x += dxabs;

         if (x >= dyabs)
         {
            x -= dyabs;
            px += sdx;
         }

         py += sdy;
         vram_s[py*640+px] = PACK_RGB565(r,g,b);
      }
   }
}

int sgn (long a)
{
   if (a > 0)
      return 1;
   else if (a < 0)
      return -1;
   else
      return 0;
}

/*

  vmu_block_read(uint8 addr, uint16 blocknum, uint8 *buffer);
  512 bytes per block
  block 241 is start of directory


  The Directory lists all the user files stored in the VMS. The Directory consists of a sequence of 32-byte entries each potentially describing a file. When the VMS is formatted, enough space is allocated to the Directory file to accommodate 200 entries. This is enough, since each file must be at least one block long, and there are only 200 blocks available for user files. The actual blocks making up the Directory can be found using the Root block and the FAT, although it should be safe to assume that the Directory has been allocated to blocks 241 through 253; 253 being the first block of the Directory, and 241 the last.

An entry in the directory is either all NUL-bytes (denoting an unused entry), or a structure describing a file. This structure looks as follows: 

0x00      : 8 bit int : file type (0x00 = no file, 0x33 = data, 0xcc = game)
0x01      : 8 bit int : copy protect (0x00 = copy ok, 0xff = copy protected)
0x02-0x03 : 16 bit int (little endian) : location of first block
0x04-0x0f : ASCII string : filename (12 characters)
0x10-0x17 : BCD timestamp (see below) : file creation time
0x18-0x19 : 16 bit int (little endian) : file size (in blocks)
0x1a-0x1b : 16 bit int (little endian) : offset of header (in blocks) from file start
0x1c-0x1f : unused (all zero)






  */


